package com.eco.plugin.xx.kdxfsso.config;

import com.fr.config.*;
import com.fr.config.holder.Conf;
import com.fr.config.holder.factory.Holders;
import com.fr.intelli.record.Focus;
import com.fr.intelli.record.Original;
import com.fr.record.analyzer.EnableMetrics;

@Visualization(category = "单点登录配置")
@EnableMetrics
public class PluginSimpleConfig extends DefaultConfiguration {

    private static volatile PluginSimpleConfig config = null;

    @Focus(id="com.eco.plugin.xx.kdxfsso.config", text = "单点登录配置", source = Original.PLUGIN)
    public static PluginSimpleConfig getInstance() {
        if (config == null) {
            config = ConfigContext.getConfigInstance(PluginSimpleConfig.class);
        }
        return config;
    }

    @Identifier(value = "privatekey", name = "解密秘钥", description = "解密秘钥", status = Status.SHOW)
    private Conf<String> privatekey = Holders.simple("");

    @Identifier(value = "timeout", name = "token超时时间(s)", description = "token超时时间(s)", status = Status.SHOW)
    private Conf<String> timeout = Holders.simple("");

    @Identifier(value = "paramname", name = "token参数名", description = "token参数名", status = Status.SHOW)
    private Conf<String> paramname = Holders.simple("");

    public String getPrivatekey() {
        return privatekey.get();
    }

    public void setPrivatekey(String url) {
        this.privatekey.set(url);
    }

    public String getTimeout() {
        return timeout.get();
    }

    public void setTimeout(String url) {
        this.timeout.set(url);
    }

    public String getParamname() {
        return paramname.get();
    }

    public void setParamname(String url) {
        this.paramname.set(url);
    }

    @Override
    public Object clone() throws CloneNotSupportedException {
        PluginSimpleConfig cloned = (PluginSimpleConfig) super.clone();
//        cloned.text = (Conf<String>) text.clone();
//        cloned.count = (Conf<Integer>) count.clone();
//        cloned.price = (Conf<Double>) price.clone();
//        cloned.time = (Conf<Long>) time.clone();
//        cloned.student = (Conf<Boolean>) student.clone();
        return cloned;
    }

}
